package com.fp.persistence.pgeneral.acco;

import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.Column;
import javax.persistence.EntityManager;
import java.io.Serializable;
import javax.persistence.Table;
import com.fp.dto.hb.HibernateBean;
import java.lang.reflect.Field;
import javax.persistence.Transient;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TGENEBASEACCOUNT*/
@Entity(name="TgeneBaseAccount")
@Table(name="TGENEBASEACCOUNT")
public class TgeneBaseAccount extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TgeneBaseAccount
*/
@EmbeddedId
private TgeneBaseAccountKey pk;
@Column(name="LOCKDB", nullable=true)

/**
* Marca utilizada en el control de actualizacion de saldos de cuentas
*/
private String lockdb;

/**Contructor por defecto*/
public TgeneBaseAccount(){
}
/**Contructor de TgeneBaseAccount
@param pPk Clave Primaria del entity
*/
public TgeneBaseAccount(TgeneBaseAccountKey pPk){
 this();
 pk=pPk;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TgeneBaseAccount
*/
public static TgeneBaseAccount find(EntityManager pEntityManager,TgeneBaseAccountKey pKey) throws Exception{
    TgeneBaseAccount obj = pEntityManager.find(TgeneBaseAccount.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TgeneBaseAccount
@return El objeto que referencia a la Clave primaria de TgeneBaseAccount
*/
public TgeneBaseAccountKey getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TgeneBaseAccount
@param pPk El objeto que referencia a la nueva Clave primaria de TgeneBaseAccount
*/
public void setPk(TgeneBaseAccountKey pPk){
  pk=pPk;
}
/**Obtiene el valor de lockdb
@return valor de lockdb*/
public String getLockdb(){
  return lockdb;
}
/**Fija el valor de lockdb
@param pLockdb nuevo Valor de lockdb*/
public void setLockdb(String pLockdb){
  lockdb=pLockdb;
}

public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TgeneBaseAccount))return false;
    TgeneBaseAccount that = (TgeneBaseAccount) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementación del metodo hashCode de la la entidad TgeneBaseAccount
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementación toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementación de la creación de un bean en blanco TgeneBaseAccount
*/
public Object createInstance(){
 TgeneBaseAccount instance=new TgeneBaseAccount();	
 instance.setPk(new TgeneBaseAccountKey());
 return instance;
}
/**Clona la entidad TgeneBaseAccount
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TgeneBaseAccount p=(TgeneBaseAccount)this.clone();
  p.setPk((TgeneBaseAccountKey)this.pk.cloneMe());
  return p;
}
}
